#include "QtOpenGLDemo_Icos.h"
#include <iostream>
#include <QColorDialog>
#include <qtimer.h>

QtOpenGLDemo_Icos::QtOpenGLDemo_Icos(QWidget *parent) : QMainWindow(parent) {
    this->ui.setupUi(this);

	this->timer = new QTimer(this);
	connect(this->timer, SIGNAL(timeout()), this, SLOT(onTimeout()));
	this->timer->setInterval(33);
	this->timer->start();
}

void QtOpenGLDemo_Icos::changeLevel(int level) {
	std::cout << "Level " << level << std::endl;
	this->ui.viewport->subdivision = level;
	this->ui.viewport->update();
}

void QtOpenGLDemo_Icos::changeColor() {
	QColor color = QColorDialog::getColor(Qt::yellow, this);

	if ( color.isValid() )
	{
		std::cout << color.red() << std::endl;
		std::cout << color.green() << std::endl;
		std::cout << color.blue() << std::endl;

		this->ui.viewport->mat_r = color.red() / 255.0f;
		this->ui.viewport->mat_g = color.green() / 255.0f;
		this->ui.viewport->mat_b = color.blue() / 255.0f;
	}

	this->ui.viewport->update();
}

void QtOpenGLDemo_Icos::onTimeout() {
	std::cout << "timeout!" << std::endl;
	this->ui.viewport->update();
}


